function MU = mufuncnormMPEC(theta2)

% MUFUNCNORM
% Computes the utility associated with the unobserved component of the r.c.'s.
%
% source: Dube, Fox and Su (2008)
% Code Revised: April 2008

global x v K

for i = 1:K+1
    nu(i,:) = theta2(i)*v(i,:);
end
MU = x*nu;
