function Dg = mkderivGMMnorm(theta1,theta,DELTA);

global x1 x2 IV W

Dg = zeros(length(theta1)+length(theta),length(W));

delta = meanvalnorm(theta);	% invert out the mean utilities

for ii = 1:length(theta1),
    thetaup = theta1;
    thetadown = theta1;
    dd = abs(thetaup(ii)*DELTA);
    thetaup(ii) = thetaup(ii) + dd;
    thetadown(ii) = thetadown(ii) - dd;
    residup = delta - x1*thetaup;
    residdown = delta - x1*thetadown;
    gup = residup'*IV;
    gdown = residdown'*IV;
    Dg(ii,:) = (gup-gdown)/(2*dd);
end

for ii = 1:length(theta),
    thetaup = theta;
    thetadown = theta;
    dd = abs(thetaup(ii)*DELTA);
    thetaup(ii) = thetaup(ii)+dd;
    thetadown(ii) = thetadown(ii)-dd;
    deltaup = meanvalnorm(thetaup);
    deltadown = meanvalnorm(thetadown);
    residup = deltaup - x1*theta1;
    residdown = deltadown - x1*theta1;
    gup = residup'*IV;
    gdown = residdown'*IV;
    Dg(length(theta1)+ii,:) = (gup-gdown)/(2*dd);
end
