function invY = myinv( Y )

% MYINV
% Computes the inverse of a PSD matrix
%
% source: Dube, Fox and Su (2008)
% Code Revised: April 2008

K = length(Y);
A = chol(Y);

opts.LT=true;
Ax = linsolve(A',eye(K),opts);
opts.LT=false;
opts.UT=true;
invY = linsolve( A , Ax, opts );